<template>
  <tasks-view title="Upcoming" icon="calendar" color="orange">
    <template v-slot:tasks>
      <div v-if="days.size < 1">
        <div v-if="neverUsed" class="flex flex-col items-center text-center px-8 py-16">
          <img :src="RunnerStart" alt="" style="height: 20rem" class="px-8" />
          <div class="mt-16 font-bold">The Upcoming View.</div>
          <div class="mt-2 text-gray-700 text-sm">
            If you are waiting for someone or have postponed one of your tasks, the corresponding task will be shown
            here!
          </div>
        </div>
        <div v-else class="flex flex-col items-center text-center px-8 py-16">
          <img :src="AllDone" alt="" style="height: 20rem" class="px-8" />
          <div class="mt-16 font-bold">There are no tasks coming your way.</div>
          <div class="mt-2 text-gray-700 text-sm">
            If you are waiting for someone or have postponed one of your tasks, the corresponding task will be shown
            here!
          </div>
        </div>
      </div>
      <div v-for="[day, tasks] of days" :key="day" class="mb-8">
        <div class="font-bold mb-2">
          {{ day }}
        </div>
        <tasks-item :thin="isMobile" v-for="task of tasks" :key="task.id" :task="task" class="mt-1" workspace />
      </div>
    </template>
  </tasks-view>
</template>

<script lang="ts">
import ViewHeader from "@/components/ViewHeader.vue";
import TasksItem from "@/components/Tasks/Item.vue";
import TasksView from "@/components/Tasks/TasksView.vue";
import { computed } from "vue";
import Task from "@/models/Task";
import { isMobile } from "@/use/responsive";
import RunnerStart from "@/assets/img/undraw_add_notes.svg";
import AllDone from "@/assets/img/undraw_relaxation.svg";
import { watchedRef } from "@/use/watchedRef";
import { asyncCache } from "@/use/cache";
import { DateTime } from "luxon";

class GroupedArray<Key, Item> extends Map<Key, Item[]> {
  push(group: Key, ...item: Item[]) {
    if (!this.has(group)) {
      this.set(group, []);
    }
    return this.get(group)!.push(...item);
  }
}

const getUpcoming = () => {
  const days = new GroupedArray<DateTime | "indefinite", Task>();
  const tasks = Task.query()
    .apply("pending")
    .getSync();

  for (const task of tasks) {
    days.push(task.postponedUntil?.startOf("day") || "indefinite", task);
  }

  return Array.from(days.entries())
    .sort(([a], [b]) => {
      if (a == "indefinite" || b == "indefinite") {
        if (a == b) return 0;
        if (a == "indefinite") return 1;
        return -1;
      }
      if (a > b) return 1;
      if (a < b) return -1;
      return 0;
    })
    .map(([date, tasks]) => [date.toLocaleString({ weekday: "short", month: "short", day: "2-digit" }), tasks]);
};

export default {
  components: { ViewHeader, TasksItem, TasksView },
  setup() {
    const days = computed(() => getUpcoming());
    return {
      days,
      isMobile,
      RunnerStart,
      AllDone,
      neverUsed: watchedRef(() =>
        asyncCache.make("neverusedupcoming", () =>
          Task.query()
            .apply("pendingRaw")
            .first()
            .then(first => first == undefined)
        )
      )
    };
  }
};
</script>
